Bonjour, je cherche a réaliser une fiche de débit de manière automatique depuis solidwokrs. J’ai donc commencé par récupérer les informations d’épaisseur, profondeur, longueur, angle de découpe…
Je viens de tomber sur une extrusion mince, qui est défini en faisant référence a des surfaces d’un assemblage. Il n’y a donc pas la cote écrite dans la pièce. Existe il un moyen de récupérer cette profondeur.
J’ai aussi eu un autre cas ou le congé d’un tube est créer directement depuis l’esquisse liée a l’extrusion. Ainsi lorsque j’affiche les dimensions je ne suis pas en mesure de différencier la cote correspondant au congé et celle de l’épaisseur.
Voila mon code
Sub GetExtrusionDimensions()
//Initialize SolidWorks application and get the active document
Dim swApp As SldWorks.SldWorks
Dim Part As ModelDoc2
Dim Feature As Feature
Dim ExtrudeFeat As ExtrudeFeatureData
Dim DisplayDim As DisplayDimension
Dim DimVal As Dimension
Dim MsgStr As String
Set swApp = Application.SldWorks
Set Part = swApp.ActiveDoc
// Check if the active document is a part file
If Part Is Nothing Or Part.GetType <> swDocPART Then
MsgBox "Veuillez ouvrir une pièce avant d'exécuter ce script.", vbCritical
Exit Sub
End If
//Start with the first feature in the part
Set Feature = Part.FirstFeature
MsgStr = "Dimensions des extrusions :" & vbNewLine & vbNewLine
//Loop through each feature in the feature tree
Do While Not Feature Is Nothing
//Check if the feature is an extrusion
If Feature.GetTypeName2 = "Extrusion" Then
//Access extrusion-specific data
Set ExtrudeFeat = Feature.GetDefinition
If Not ExtrudeFeat Is Nothing Then
MsgStr = MsgStr & "Fonction : " & Feature.Name & vbNewLine
//Access display dimensions
Set DisplayDim = Feature.GetFirstDisplayDimension
Do While Not DisplayDim Is Nothing
//Get the linked dimension object
Set DimVal = DisplayDim.GetDimension
Depth = ExtrudeFeat.GetDepth(True)
Debug.Print Depth
If Not DimVal Is Nothing Then
MsgStr = MsgStr & " Dimension : " & DimVal.FullName & " = " & DimVal.Value & " mm" & vbNewLine
End If
//Move to the next display dimension
Set DisplayDim = Feature.GetNextDisplayDimension(DisplayDim)
Loop
MsgStr = MsgStr & vbNewLine
End If
End If
//Move to the next feature in the tree
Set Feature = Feature.GetNextFeature
Loop
//Display the extracted information
MsgBox MsgStr, vbInformation, "Résultats"
End Sub